
function randomString() 
{
	var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz";
	var string_length = 16;
	var randomstring = "";
	for (var i=0; i<string_length; i++) {
		var rnum = Math.floor(Math.random() * chars.length);
		randomstring += chars.substring(rnum,rnum+1);
	}
	return randomstring;
}

function hideAllStruct()
{
	var allElements = document.getElementsByTagName("*");

	var element;
	for (var i = 0; (element = allElements[i]) != null; i++) 
	{
		if (element.id.substring(0, 6) == "struct")
		{
			element.style.display= "none";			
		}
	}
}

function showAllStruct()
{
	var allElements = document.getElementsByTagName("*");

	var element;
	for (var i = 0; (element = allElements[i]) != null; i++) 
	{
		if (element.id.substring(0, 6) == "struct")
		{
			element.style.display= "block";			
		}
	}
}

function toggleStruct(id)
{
	var element = document.getElementById(id);
	if (element.style.display== "none")
	{
		element.style.display= "block";		
	}
	else
	{
		element.style.display= "none";
	}
}

function showSectionWithIDPrefix(prefix_length, block_id)
{
	var allElements = document.getElementsByTagName("*");

	var element;
	for (var i = 0; (element = allElements[i]) != null; i++) 
	{
		if (element.id.substring(0, prefix_length) == block_id.substring(0, prefix_length))
		{
			if (block_id == element.id)
			{
				element.style.display= "block";	
			}
			else
			{
				element.style.display= "none";
			}
		}
	}
}

function createLine(addr, len, name, value)
{
	var str = "";
	str += "<div style=\"width:650; border: 1px dotted #AAAAAA;	padding:0;\">";
	str += 	"<div style=\"	float: left; width:45; border: 0px dotted #AAAAAA;\">" + addr + "</div>";	
	str += 	"<div style=\"	float: left; width:35; border: 0px dotted #AAAAAA; text-align: right; padding-right: 10;\">" + len + "</div>";
	str += 	"<div style=\"	float: left; width:200px; border: 0px dotted #AAAAAA;\">" + name + "</div>"; 
	str += 	"<div style=\"	float: left; width:350px; border: 0px dotted #AAAAAA;\">" + value + "</div>";
	str += 	"<div style=\"clear: both;\"></div>";
	str += "</div>";

	return str;
}

function makeIndent(depth)
{
	var str = "";
	for (var i=0; i<depth; i++)
	{
		
		str += "&nbsp;&nbsp;&nbsp;";
	}

	return str;
}

function parseLine(rawdata, info_struct, iterator, addr_offset)
{
	var str = "";
	var repeat_start = iterator.value;
	var repeat_count = info_struct[iterator.value].repeat;

	for (var i=0; i<repeat_count; i++)
	{	
		iterator.value = repeat_start;
		var unique_id;
		var addr = d2h(rawdata.getFilePointer()-h2d(addr_offset), 4);
		var length = info_struct[iterator.value].length;
		var repeat = info_struct[iterator.value].repeat;
		var name = makeIndent(iterator.depth) + info_struct[iterator.value].name;
		var format = info_struct[iterator.value].format;
		var value;

		switch (format) 
		{
			case "hex":
			{
				value = rawdata.readNumber(length);
				value = d2h(value, length*2);
				break;
			}
			case "dec":
			{
				value = rawdata.readNumber(length);
				break;
			}
			case "string":
			{
				value = rawdata.readString(length);
				break;
			}
			case "decstring":
			{
				value = rawdata.readDecString(length);
				break;
			}
			case "hexstring":
			{
				value = rawdata.readHexString(length);
				break;
			}
			case "structbegin":
			{
				value = "";
				break;
			}
			default:
			{
				value = rawdata.readHexString(length);
				value = format;
			}
		}


		if (repeat > 1)
		{
			name = name + "[" + (i+1) + "/" + repeat + "]";
		}

		if (format == "structbegin")
		{
			unique_id  = "struct_" + randomString();
			name = "<span style=\"cursor: hand; color:#0000FF\" onclick='toggleStruct(\""  + unique_id + "\")'>"+ name + "</span>";
		}

		str  += createLine(addr, length, name, value);

		if (format == "structbegin")
		{
			str += "<div id=" +  unique_id + ">";
			iterator.depth++;
			while(1)
			{
				iterator.value ++;
				str += parseLine(rawdata, info_struct, iterator, addr_offset);
				if (info_struct[iterator.value].format == "structend")
				{
					break;
				}
			}
			iterator.depth--;
			str += "</div>";
		}
	}

	return str;
}

function parseData(rawdata, info_struct, title, addr_offset)
{
	var str = ""
	str += "<div style=\"padding: 20;\">" + title + "&nbsp;";
	str += "(";
	str +=  "<span style=\"color:#0000FF; cursor:hand;\" onclick='showAllStruct()'>Expand</span>";
	str += "|";
	str +=  "<span style=\"color:#0000FF; cursor:hand;\" onclick='hideAllStruct()'>Collapse</span>";
	str += ")";
	str += "</div>";
	str += createLine("Addr", "Len", "Name", "Value");
		
	var iterator = new Object();
	iterator.value = 0;
	iterator.depth = 0;
	
	for (iterator.value=0; iterator.value<info_struct.length; iterator.value++)
	{
		str += parseLine(rawdata, info_struct, iterator, addr_offset);	
	}
	
	delete iterator;

	return str;
}

