var debug_obj;

// for handling IE8 error on console.log()
if (typeof console === "undefined") {
    console = {
        log: function() {},
        info: function() {},
        warn: function() {},
        error: function() {}
    };
}

// namespace for global variables
var GLBV = GLBV || {};
GLBV.check_status_interval = 6 * 1000;  // milliseconds
GLBV.ajax_timeout = 20; // seconds

$(document).ready(function() {
    $('[data-status=BatteryLevel]').on('mouseover', function() {OnOverBatteryImg()});
    $('[data-status=BatteryLevel]').on('mouseout', function() {OnOutBatteryImg()});

    check_status();
    setInterval(check_status, GLBV.check_status_interval);

    disable_form();
    $('.btn-loading').click(function() {
        $(this).button('loading');
    });
    $('#sign_out').click(sign_out);
    $('.form-data, .dropdownLink').on('click', function() {
        $('#btn-save').button('reset');
    });
});

// =====================================================================
// Sign In/Out, Check Signed In

function go_login() {
    location.href = '/login.html';
}

function sign_out() {
    var cgi = '/vzw/cgi-bin/sign_in.cgi',
        req = { Command: 'SignOut' };
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        go_main_page
    );
}
// =====================================================================

function check_status() {
    var cgi = '/vzw/cgi-bin/general_monitor.cgi',
        req = {};
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function(data) { set_status_infos(data); }
    );
}

GLBV.need_wireless_num = false;   // only needed in index.html
GLBV.sim_state_checked = false;
function set_status_infos(status) {
    //console.log('. set_status_infos()', status);
    var jqo_signal = $('[data-status=SignalStrength]');
    var jqo_battery = $('[data-status=BatteryLevel]');
    var jqo_txrx = $('[data-status=TxRx]');
    var jqo_roam = $('[data-status=Roam]');

    if (status['SIMDetect'] === 1) { // 1 : SIM_STATE_NORMAL
        jqo_signal = $('[data-status=SignalStrength]');
        jqo_signal.prop('src', '/images/icons/icn-signal-' + status['SignalStrength'] + '.png');
        jqo_signal.removeClass('fti-cursor-pointer');
        jqo_signal.off('click');
        if (GLBV.need_wireless_num) {
            var cgi = '/vzw/cgi-bin/about_diagnostics.cgi',
                req = { Command: "GetDiagnostics" };
            load_page_data(cgi, req, set_wireless_num);
        }
    } else { // 0 : SIM_STATE_NONE or 2 : SIM_STATE_ERROR or 3 : SIM_STATE_LOCKED
        jqo_signal.prop('src', '/images/icons/icn-sim-' + status['SIMDetect'] + '.png');
        if (GLBV.sim_state_checked) {
            return;
        }
        if (status['SIMDetect'] === 0 && is_main_or_sim_page()) {
            // 0 : SIM_STATE_NONE
            show_no_sim_modal();
        } else if (status['SIMDetect'] === 2 && is_main_or_sim_page()) {
            // 2 : SIM_STATE_ERROR
            show_sim_error_modal();
        } else if (status['SIMDetect'] === 3) {
            // 3 : SIM_STATE_LOCKED
            if (is_main_page()) {
                request_pin_status();
            } else {
                go_main_page();
                return;
            }
        }
        GLBV.sim_state_checked = true;
    }

    if (status['BatteryLevel'] === 6) {  // Full Charged
        jqo_battery.prop('src', '/images/icons/icn-battery-5.png');
    } else if (status['BatteryState'] === 2) {  // Charging
        jqo_battery.prop('src', '/images/icons/icn-battery-charging.png');
    } else {
        jqo_battery.prop('src', '/images/icons/icn-battery-' + status['BatteryLevel'] + '.png');
    }
	var jqo_battery_capacity = $('#BatteryCapacity_top');
	jqo_battery_capacity.text(status['BatteryCapacity']);

    jqo_roam.prop('src', '/images/icons/icn-roam-' + status['Roam'] + '.png');
    $('[data-status=Network4G]').prop('src', '/images/icons/icn-network-4g.png');

    if (! is_connected_devices_page()) {
        set_connected_devices_count_badge(status['NumberOfDevices']);
    }
    if (! is_messages_page()) {
        set_messages_count_badge(status['NumberOfMessage']);
    }
}

function set_wireless_num(data) {
    var msisdn, len, wireless_num;
    msisdn = data['MSISDN'];
    if (msisdn) {
        len = msisdn.length;
        wireless_num = msisdn.substr(len - 10, 3) + '-' + msisdn.substr(len - 7, 3) + '-' + msisdn.substr(len - 4, 4);
        set_value_by_id('wireless_num', wireless_num);
        // setting wireless num done
        GLBV.need_wireless_num = false;
        console.log('. set_wireless_num() :', wireless_num);
    }
}

//----------------------------------------------------------------------
// request_connected_devices_count() is not used now.
function request_connected_devices_count() {
    console.log('. request_connected_devices_count()');
    var cgi = '/vzw/cgi-bin/connected_devices.cgi',
        req = { Command: "GetConnectedDevices" };
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function (data) {
            console.log('. request_connected_devices_count() : get_json_by_post - SUCCESS :', data);
            set_connected_devices_count_badge(data['NumberOfDevices']);
        }
    );
}

function set_connected_devices_count_badge(count) {
    if (count === 99) {
        console.log(". set_connected_devices_count_badge() : Connected Device reaches the MAX number");
        $('.badge-connected_devices-fti').html("MAX").show();
    } else {
        $('.badge-connected_devices-fti').html(count).show();
    }
}

function set_messages_count_badge(count) {
    if (count > 0) {
        $('.badge-messages-fti').html(count).show();
    } else {
        $('.badge-messages-fti').html(count).hide();
    }
}

//----------------------------------------------------------------------
GLBV.refresh_page_data = false;
function load_page_data(cgi, req, load_handler) {
    console.log('- load_page_data() :', JSON.stringify(req));
    load_handler = (typeof load_handler === 'function')
        ? load_handler : set_page_data;
    console.log('. load_page_data() : load_handler - ' + load_handler.name);
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function(data) {
              console.log('. load_page_data() : get_json_by_post - SUCCESS :', data);
              enable_form('', GLBV.refresh_page_data);
              GLBV.refresh_page_data = true;
              load_handler(data);
              $(document).trigger('load.done');
        },
        function (jqxhr, status, err) {
            console.error('. load_page_data() : get_json_by_post - ERROR :', err);
            $(document).trigger('load.error');
        }
    );
}

function set_page_data(data) {
    console.log('- set_page_data()');
    for (var id in data) {
        console.log('. set_page_data() : call set_value - ' + id + ', ' + data[id]);
        set_value_by_id(id, data[id]);
    }
}

function set_value_by_id(id, value) {
    var target = $('#' + id);
    if (! target.get(0) || ! target.get(0).tagName) {
        console.warn('w set_value_by_id() : invalid id -', id);
        return;
    }
    var type = target.get(0).tagName;
    if (type === 'INPUT') {
        type = target.attr('type');
    }
    switch (type) {
        case 'text':
        case 'hidden':
        case 'password':
            target.val(value);
            break;

        case 'radio':
            $('[name=' + id + '][value=' + value + ']').prop('checked', true);
            break;

        case 'checkbox':
            target.prop('checked', getParseBool(value));
            break;

        case 'SELECT':
            target.val(value);
            if (target.hasClass('dropdown') && typeof VZWDropdown !== 'undefined') {
                VZWDropdown.setOption(id, value);
            }
            break;

        case 'SPAN':
        case 'DIV':
        case 'P':
        case 'TD':
            target.html(value);
            break;

        default:
            console.warn('w set_value : not supported type - ' + type);
            return;
            break;
    }
}

//----------------------------------------------------------------------

function set_save_action(cgi, save_callback) {
    console.log('- set_save_action() : ' + cgi);
    var handler = function() {
        console.log('- save handler called : saving...');
        if (! validate_form()) {
            console.log('. save handler : validation failed.');
            return false;
        }
        $('#btn-save').button('loading');
        $('.form-data').prop('disabled', true);
        save_data(cgi, save_callback);
        return false;   // for stopping form submit
    };
    $('#btn-save').on('click', handler);
    $('#frm-save').on('submit', handler);
}


// MUST! add 'form-data' class to element to save
// add 'form-data-int', 'form-data-bool', 'form-data-str' class for data type
// default : string except checkbox
var last_focused_element;
function save_data(cgi, save_callback) {
    console.log('- save_data() : ' + cgi);
    var data, req, key, jqo;
    data = $('.form-data');
    req = {};

    for (var i = 0; i < data.length; i++) {
        elm = data[i];
        key = data[i].id;
        if (key) {
            req[key] = get_value(data[i]);
        }
    }
    console.log('. save_data() : make req done', req);

    $(document).trigger('save.start');
    last_focused_element = $(':focus')[0];
    GLBV.request_save_time = getTimestamp();
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function (data) {
            console.log('. save_data() : get_json_by_post - SUCCESS :', data);
            enable_form('', true);
            if (typeof save_callback === 'function') {
                console.log('. save_data() : call save_callback - ', save_callback.name);
                save_callback(data);
            }

            if (data['Response'] === 'success') {
               $(document).trigger('save.succeed');
            } else if (data['Response'] === 'Success') {
               $(document).trigger('save.succeed');
            } else {
               $(document).trigger('save.error');
            }
        },
        function (jqxhr, status, err) {
            console.error('. save_data() : get_json_by_post - ERROR :', err);
            $(document).trigger('save.error');
        }
    );
}


/* ------------------------------------------------------------------
  These are modification of set_save_action(), save_data().
-------------------------------------------------------------------*/
var set_response, check_status_ready, req_check_status, reload_callback;

function set_save_reconnect_action(cgi, cgi_param_check, finish_callback)
{
	reload_callback = finish_callback;
	
    req_check_status = function() { 
		setTimeout(function() {load_page_data(cgi, cgi_param_check, check_status_ready);}, 3000); 
	};
	
    console.log('- set_save_reconnect_action() : ' + cgi);
    var handler = function() {
        console.log('- save handler called : saving...');
        if (! validate_form()) {
            console.log('. save handler : validation failed.');
            return false;
        }
        $('#btn-save').button('loading');
        $('.form-data').prop('disabled', true);
        save_data_step1(cgi, req_check_status);
        return false;   // for stopping form submit
    };
    $('#btn-save').on('click', handler);
    $('#frm-save').on('submit', handler);
}

function check_status_ready(data) {
	if(data["PFStatus"] != "Ready"){
		req_check_status();
		return;
	}
	save_data_step2();
};

function save_data_step1(cgi, req_check_status) {
    console.log('- save_data() : ' + cgi);
    var data, req, key, jqo;
    data = $('.form-data');
    req = {};

    for (var i = 0; i < data.length; i++) {
        elm = data[i];
        key = data[i].id;
        if (key) {
            req[key] = get_value(data[i]);
        }
    }
    console.log('. save_data() : make req done', req);

    $(document).trigger('save.start');
    last_focused_element = $(':focus')[0];
    GLBV.request_save_time = getTimestamp();
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function (data) {
            console.log('. save_data() : get_json_by_post - SUCCESS :', data);
            if (typeof req_check_status === 'function') {
                console.log('. saving_data() : call save_callback - ', req_check_status.name);
                req_check_status(data);
            }
			set_response = data['Response'];
        },
        function (jqxhr, status, err) {
            console.error('. saving_data() : get_json_by_post - ERROR :', err);
            $(document).trigger('save.error');
        }
    );
}


function save_data_step2() {
    enable_form('', true);
    if (set_response === 'success') {
       $(document).trigger('save.succeed');
    } else if (set_response === 'Success') {
       $(document).trigger('save.succeed');
    } else {
       $(document).trigger('save.error');
    }
    reload_callback();
}

function get_request_save_laps() {
    return getTimestamp() - GLBV.request_save_time;
}

function enable_form(elm, saved) {
    console.log('. enable_form() :', elm, last_focused_element);
    $('.form-data').prop('disabled', false);
    if (elm) {
        elm.select();
        elm.focus();
    } else if (last_focused_element) {
        // last_focused_element is set in save_data()
        $(last_focused_element).focus();
        last_focused_element = null;
    }
    $('#btn-save').prop('disabled', false);
    $('#btn-save').button('reset');
    if (saved) {
        $('#btn-save').text('Saved');
    }
}

function disable_form() {
    $('#btn-save').prop('disabled', true);
    $('.form-data').prop('disabled', true);
}

// target is string, element or jquery object
function get_value(target) {
    console.log('. get_value() :', target, typeof target);
    var value, elm, jqo, type;
    if (typeof target === 'string') {
    // css selector
        jqo = $(target);
        elm = jqo[0];
    } else if (isElement(target)) {
    // html element
        jqo = $(target);
        elm = target;
    } else if (isJqueryObject(target)) {
    // jquery object
        jqo = target;
        elm = jqo[0];
    } else {
    // unsupported target
        console.warn('w get_value() : unsupported target -', target);
        return;
    }

    if (! elm || ! elm.tagName) {
        console.warn('w get_value() : invalid target -', target);
        return;
    }

    var type = elm.tagName;
    if (type === 'INPUT') {
        type = elm.type;
    }

    switch (type) {
        case 'text':
        case 'hidden':
        case 'password':
            value = jqo.val();
            break;

        case 'radio':
            value = $('[name=' + jqo.attr('name') + ']:checked').val();
            break;

        case 'checkbox':
            value = jqo.is(':checked'); // boolean
            break;

        case 'SELECT':
            value = jqo.val();
            break;

        case 'SPAN':
        case 'DIV':
        case 'P':
        case 'TD':
            value = jqo.html();
            break;

        default:
            console.warn('w get_value : not supported type - ' + type);
            return;
            break;
    }
    if (jqo.hasClass('form-data-int')) {
        value = getParseInt(value);
    } else if (jqo.hasClass('form-data-bool')) {
        value = getParseBool(value);
    }
    return value;
}

// ---------------------------------------------------------------------
// simple implemation of get_json_by_post using $.ajax
function get_json_by_post(url, data, success, error) {
    if (error === undefined) {
        error = function (jqxhr, status, err) {
            console.error('e get_json_by_post() error: ' + url + ' : ' + status + ' : ' + err);
        }
    }
    $.ajax({
        type: "POST",
        dataType: "json",
        timeout: GLBV.ajax_timeout * 1000,
        url: url,
        data: data,
        success: success,
        error: error
    });
}

// ---------------------------------------------------------------------

function validate_form() {
    console.log('- validate_form()');
    var data = $('.form-data');
    for (var i = 0; i < data.length; i++) {
        elm = data[i];
        if (! validate_form_data(elm)) {
            console.log('. validate_form() : validation failed.');
            return false;
        }
    }
    // pass all validation
    console.log('. validate_form() : all validation passed');
    return true;
}

function validate_form_data(elm) {
    var jqo, validator, value, validator_infos, cmd, rule, title, msg,
        mandatory, action, result, re, passed;
    jqo = $(elm);
    validator = jqo.data('validator');
    if (! validator) {
        return true;
    } else if (jqo.prop('disabled')) {
        return true;
    } else {
        value = $.trim($(elm).val());
        validator_infos = validator.split('||');
        cmd   = validator_infos[0];
        rule  = validator_infos[1];
        title = validator_infos[2];
        msg   = validator_infos[3] ? validator_infos[3] : title;

        // M : mandatory , O : optional - check only when value exists
        mandatory = cmd.substr(0, 1).toUpperCase();
        // R : RegExp, P : preset pattern, M : match - css selector, F : function
        action = cmd.substr(1, 1).toUpperCase();
        if (mandatory === 'O' && ! value) {
            console.log('. validate_form_data() : optional and no value');
            return true;
        }
        switch (action) {
            case 'R':
                value = $(elm).val();
                re = new RegExp(rule);
                console.log('. validate_from_data() R:', rule, re);
                passed = re.test(value);
                break;
            case 'P':
                re = new RegExp(get_preset_pattern(rule));
                console.log('. validate_from_data() P:', rule, re);
                passed = re.test(value);
                break;
            case 'M':
                console.log('. validate_from_data() M:', value, $('' + rule).val());
                passed = $('' + rule).val() === value;
                elm =  $('' + rule)[0]; // for focusing first element
                break;
            case 'F':
                console.log('. validate_from_data() F:', rule, typeof window[rule]);
                passed = (typeof window[rule] === 'function') && window[rule](value);
                break;
            default:
                // true when there is no proper action
                console.log('. validate_from_data() : no proper action');
                passed = true;
                break;
        }
        if (passed) {
            return true;
        } else {
            show_error_modal(title, msg, function() { enable_form(elm); });
            return false;
        }
    }
}

function get_preset_pattern(preset) {
    // should use \\ for \ in RegExp
    patterns = {};
    patterns['ipaddress'] = '^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$';
    patterns['int'] = '^\\d+$';
    patterns['anyword'] = '^\\w+$';
    return patterns[preset];
}

// ---------------------------------------------------------------------
	var tmr_batt_over = null;
    function OnOverBatteryImg() {
    	if(tmr_batt_over != null){
	    	clearInterval(tmr_batt_over);
	    	tmr_batt_over = null;
	    }
    	ShowBatteryCapacity();
    }

    function OnOutBatteryImg() {
    	if(tmr_batt_over != null){
	    	clearInterval(tmr_batt_over);
	    	tmr_batt_over = null;
	    }
	    tmr_batt_over = setInterval(HideBatteryCapacity, 300);
    }

    function ShowBatteryCapacity() {
//		alert("show");
        var div = document.getElementById("div_battery");
        var img = $('[data-status=BatteryLevel]')[0];
        var pos = getPosition(img);
		// note: battery icon size is 34 by 25
        div.style.left = pos.x - 70 - 4 + "px";
        div.style.top = pos.y + 25 + "px";  
        div.style.width = 34 + 2 * 70 + "px";
        div.style.height = "25px";
	    div.style.zIndex = "1001";
        div.style.display = "";
    }

    function HideBatteryCapacity() {
//		alert("hide");
        var div = document.getElementById("div_battery");
        div.style.display = "none";
    }

    function getPosition(element) {
        var xPosition = 0;
        var yPosition = 0;
	  
        while(element) {
            xPosition += (element.offsetLeft - element.scrollLeft + element.clientLeft);
            yPosition += (element.offsetTop - element.scrollTop + element.clientTop);
            element = element.offsetParent;
        }
        return { x: xPosition, y: yPosition };
    }

// ---------------------------------------------------------------------

function go_main_page() {
    location.href = '/vzw/';
}

function is_main_page() {
    return location.pathname === '/vzw/' || location.pathname === '/vzw/index.html';
}

function is_main_or_sim_page() {
    return is_main_page() || location.pathname === '/jetpack_settings/adv_sim.html';
}

function is_connected_devices_page() {
    return location.pathname === '/connected_devices/' || location.pathname === '/connected_devices/index.html';
}

function is_messages_page() {
    return location.pathname === '/messages/' || location.pathname === '/messages/index.html';
}

// common js help functions
// ---------------------------------------------------------------------

function getParseBool(obj) {
    return (obj === true || String(obj).toLowerCase() === 'true')
}

function getParseInt(obj) {
    return isNaN(parseInt(obj)) ? 0 : parseInt(obj);
}

function getParseFloat(obj) {
    return isNaN(parseFloat(obj)) ? 0 : parseFloat(obj);
}

function isElement(obj) {
    return !!(obj && obj.nodeType !== undefined);
}

function isJqueryObject(obj) {
    return (typeof jQuery !== 'undefined') && (obj instanceof jQuery)
}

function getTimestamp() {
    return parseInt(+new Date() / 1000);
}

function isOsMac() {
    return navigator.platform.substr(0, 3) == 'Mac';
}
