var GLBV = GLBV || {};

var signin_msg_default = 'Please enter the admin password.<br>(The Admin Password is the same as the Wi-Fi Password unless you create a separate Admin Password.)';
var signin_msg_no_pwd = '<span class="fti-text-alert">No Password.<br>Please enter the admin password.</span><br>(The Admin Password is the same as the Wi-Fi Password unless you create a separate Admin Password.)';
var signin_msg_wrong_pwd = '<span class="fti-text-alert">Please verify you have the correct Password and try again.</span><br>(The Admin Password is the same as the Wi-Fi Password unless you create a separate Admin Password)';

var sec_answer_msg_default = '';
var sec_answer_msg_no_answer = '<span class="fti-text-alert">Please answer security question.</span><br>';
var sec_answer_msg_wrong_answer = '<span class="fti-text-alert">Your answer is incorrect. Please try again.</span><br>';

$(document).ready(function() {
    $('#sign_in').on('click', function() { set_redirect_url(''); });

    // Need set explicit submit handler for IE
    $('#btn-signin').on('click', request_signin);
    $('#frm_signin').on('submit', request_signin);

    $('#btn-answer').on('click', check_security_answer);
    $('#frm_security_answer').on('submit', check_security_answer);

    $('#div_signin').on('show.bs.collapse', prepare_frm_signin);
    $('#div_signin').on('shown.bs.collapse', function() {
        $('#Password').focus();
    });
    $('#div_signin').on('hidden.bs.collapse', function() {
        $('#Password').blur();
    });

    $('#go_forgot_pwd').on('click', go_forget_password);

    $('.check-capslock').on('keypress', function(e) {
        var c = String.fromCharCode( e.which );
        if (c.toUpperCase() === c && c.toLowerCase() !== c && !e.shiftKey) {
            console.log('. check-capslock: caps lock is on.');
            $('.check-capslock-msg').html('Caps Lock is On!');
        } else {
            $('.check-capslock-msg').html('');
        }
    });

    check_default_password_changed();
    // request_signin_state() also check signin and redirect request by hash
    set_redirect_url_from_hash();
    request_signin_state();
});

// =====================================================================

function request_signin_state() {
    var cgi = '/vzw/cgi-bin/sign_in.cgi',
        req = { Command: 'Status' };
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        check_signin_state_response
    );
}

function check_signin_state_response(data) {
    console.log('. check_signin_state_response() :', data);
    if (data['Response'] === 'Success') {
        if (get_redirect_url()) {
            location.href = get_redirect_url();
        } else {
            toggle_sign_inout('signout');
            set_link_on();
        }
    } else {
        toggle_sign_inout('signin');
        set_link_off();
        request_security_question();
        if (get_redirect_url()) {
            show_signin_form();
        }
    }
}

// =====================================================================

function request_signin() {
    if (! $('#Password').val()) {
        $('#signin_msg').html(signin_msg_no_pwd);
        return false;
    }
    var cgi = '/vzw/cgi-bin/sign_in.cgi',
        req = { Command: "SignIn", Password: $('#Password').val() };
    console.log('- request_signin() :', req);
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        check_signin_response
    );
    return false;   // for stopping form submit
}

function check_signin_response(data) {
    console.log('. check_signin_response() :', data);
    if (data['Response'] === 'Success') {
        signin_success();
    } else {
        signin_fail();
    }
}

function signin_success() {
    console.log('- signin_success()');
    if (is_login_page()) {
        go_main_page();
    } else if (get_redirect_url()) {
        location.href = get_redirect_url();
    } else {
        $('#div_signin').collapse('hide');
        toggle_sign_inout('signout');
        set_link_on();
    }
}

function signin_fail() {
    console.log('- signin_fail()');
    $('#Password').focus().select();
    $('#signin_msg').html(signin_msg_wrong_pwd);
}

function toggle_sign_inout(sign_inout) {
    if (sign_inout === 'signin') {
        $('#signin_menu').show();
        $('#signout_menu').hide();
    } else {
        $('#signin_menu').hide();
        $('#signout_menu').show();
    }
}

// =====================================================================

function go_forget_password() {
    $('#div_form_signin').hide();
    $('#div_form_security_answer').show();
    $('#SecurityAnswer').focus();
}

function request_security_question() {
    console.log('- request_security_question()');
    var cgi = '/vzw/cgi-bin/sign_in.cgi',
        req = { Command: "SecurityQuestion" };
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        check_security_question_response
    );
    return false;
}

function check_security_question_response(data) {
    console.log('- check_security_question_response() :', data);
    var sec_qst_code = data['SecurityQuestion'],
        sec_qst = { DateOfBirth : 'What is your Date of Birth (mmddyy)?',
                    MothersMaidenName : 'What is your mother\'s maiden name?',
                    NameOfStreet : 'What is the name of the street you grew up on?' };
    if (sec_qst[sec_qst_code]) {
        $('#sec_question').html(sec_qst[sec_qst_code]);
    }
}

// =====================================================================

function check_security_answer() {
    if (! $('#SecurityAnswer').val()) {
        $('#sec_answer_msg').html(sec_answer_msg_no_answer);
        return false;
    }
    var cgi = '/vzw/cgi-bin/sign_in.cgi',
        req = { Command: "SecurityAnswer", SecurityAnswer: $('#SecurityAnswer').val() };
    console.log('- check_security_answer()', req);
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        check_security_answer_response
    );
    return false;
}

function check_security_answer_response(result) {
    if (result['Response'] === 'Success') {
        security_question_success(result['CurrentPassword']);
    } else {
        security_question_fail();
    }
}

function security_question_success(pwd) {
    console.log('- security_question_success() :', pwd);
    $('#div_form_signin').show();
    $('#div_form_security_answer').hide();
    $('#signin_msg').html('Your Admin Password is \'<b>' + pwd + '</b>\'');
    $('#Password').val(pwd);
    $('#Password').prop('placeholder', pwd);
    $('#Password').focus();
    $('#link_forgot_password').hide();
}

function security_question_fail() {
    console.log('- security_question_fail()');
    $('#SecurityAnswer').focus().select();
    $('#sec_answer_msg').html(sec_answer_msg_wrong_answer);
}

// =====================================================================

function show_signin_form() {
    $('#div_signin').collapse('show');
    $('#Password').focus();
}

function prepare_frm_signin() {
    console.log('. prepare_frm_signin()');

    pos = $('#signin_menu').offset();
    // use .css() because of some buggy action of hidden_element.offset()
    $('#div_signin').css('top', (pos.top + 56) + 'px');
    $('#div_signin').css('left', (pos.left - 244) + 'px');

    // toggle to signin form
    $('#div_form_signin').show();
    $('#div_form_security_answer').hide();
    // clear form
    $('#signin_msg').html(signin_msg_default);
    $('#sec_answer_msg').html(sec_answer_msg_default);
    $('#Password').val('');
    $('#Password').prop('placeholder', 'Admin Password');
    $('#SecurityAnswer').val('');
    $('.check-capslock-msg').html('');
}

function check_default_password_changed() {
    var cgi = '/vzw/cgi-bin/sign_in.cgi',
        req = { Command: "DefaultPassword" };
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function(data) {
            console.log('- check_default_password_changed()', data);
            if (data['Response'] === "Default") {
                $('#link_forgot_password').hide();
            } else {
                $('#link_forgot_password').show();
            }
        }
    );
}

// =====================================================================

function set_link_on() {
    console.log('. set_link_on()');
    $('.link-need-signin').off('click');
    $('.link-need-signin').each(function() {
        $(this).prop('href', $(this).data('link'));
    });
}

function set_link_off() {
    console.log('. set_link_off()');
    $('.link-need-signin').on('click', function() {
        console.log('. set_link_off() : link clicked');
        set_redirect_url($(this).data('link'));
        show_signin_form();
    });
}

// =====================================================================

GLBV.redirect_url = '';
function set_redirect_url(url) {
    GLBV.redirect_url = url;
}

function get_redirect_url() {
    return GLBV.redirect_url;
}

function set_redirect_url_from_hash() {
    var hash = window.location.hash;
    if (hash.search('#login=') === 0) {
        console.log('. set_redirect_url_from_hash() :', hash);
        set_redirect_url(hash.substr(7));
    }
}

// =====================================================================

function is_login_page() {
    return location.pathname === '/login.html';
}

function is_main_page() {
    return location.pathname === '/' || location.pathname === '/index.html';
}
