/*
 * software install and download script
 *
 */

var GLBV = GLBV || {};
GLBV.check_progress_interval = 2 * 1000; // milliseconds
GLBV.wait_interval = 3 * 1000; // milliseconds

$(document).ready(function() {

});

function check_update_available() {
    console.log('- check_update_available()');
    // check update available via general_monitor.cgi will be removed.
    return;
    var cgi = '/vzw/cgi-bin/general_monitor.cgi',
        req = { Command: ''};
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function (data) {
            console.log('. check_update_available() : get_json_by_post - SUCCESS :', data);
            data['NewSwAvailable'] === 1 ? show_update_available() : '';
        }
    );
}

//----------------------------------------------------------------------

function check_fota_status() {
    console.log('- check_fota_status()');
    // set modal window
    set_modal_lock();
    title = 'Checking for Update';
    msg = 'Checking for new software for Ellipsis Jetpack.<br><br>'
        + '<p class="text-center"><img src="/images/spinner.gif"></p><br>'
        + '<p class="text-center">Please wait...</p>';
    show_modal(title, msg);
    // request check download available
    var cgi = '/vzw/cgi-bin/settings_software_update.cgi',
        req = { Command: 'CheckFotaStatus'};
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        check_fota_status_response,
	check_fota_status_error
    );
}

function check_fota_status_response(data) {
    console.log('- check_fota_status()', data);
    switch (data['FotaStatus']) {
        case 0:
            download_unavailable();
            break;
        case 1:
	    setTimeout(check_download_available, GLBV.wait_interval);
            break;
        case 2:
            download_otadm_background();
            break;
        case 3:
            download_network_error();
            break;
        case 4:
            show_update_available();
            break;
    }
    console.log('- check_fota_status() END', data);
}

function check_fota_status_error(jqxhr, status, err) {
    console.error('e check_fota_status() : get_json_by_post - ERROR :', status, err);
    set_ok_modal();
    title = 'Checking for Software Update';
    msg = 'There was a problem checking software update available.<br>'
        + 'Please try later.';
    set_modal_content(title, msg);
}

function check_download_available() {
    console.log('- check_download_available()');
    // request check download available
    var cgi = '/vzw/cgi-bin/settings_software_update.cgi',
        req = { Command: 'CheckAvailableSw'};
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        check_download_available_response,
        check_download_available_error
    );
}

function check_download_available_response(data) {
    console.log('- check_download_available_response()', data);
    switch (data['NewSoftwareReadyToDownload']) {
        case 0:
            download_unavailable();
            break;
        case 1:
            download_now();
            break;
        case 2:
            setTimeout(check_download_available, GLBV.check_progress_interval);
            break;
        case 4:
            show_update_available();
	    break;
    }
}

function check_download_available_error(jqxhr, status, err) {
    console.error('e check_download_available_error() : get_json_by_post - ERROR :', status, err);
    set_ok_modal();
    title = 'Checking for Software Update';
    msg = 'There was a problem checking software update available.<br>'
        + 'Please try later.';
    set_modal_content(title, msg);
}

function download_available() {
    console.log('- download_available()');
    set_modal_unlock();
    set_ok_cancel_modal();
    set_modal_button('.btn-ok', 'Download Now', false);
    set_modal_button('.btn-cancel', 'Download Later', true);
    title = 'New Software Available';
    msg = 'A new software update is available. Would you like to download? '
        + 'Downloading won\'t interrupt your current connection.';
    set_modal_content(title, msg);

    // set_ok_cancel_modal() calls unbind_answer_handler();
    bind_answer_handler('ok', download_now);
    bind_answer_handler('cancel', download_later);

    // Request DownloadNow automatically after 1 min.
    GLBV.tmr_download = setTimeout(
        function() {
            console.log('. download_available() : 1 min passed. request DownloadNow automatically.');
            hide_modal();
            var cgi = '/vzw/cgi-bin/settings_software_update.cgi',
                req = { Command : "DownloadNow" };
            get_json_by_post(
                cgi,
                JSON.stringify(req),
                function (data) {
                    console.log('. download_available() : automatic download request DONE -', data);
                }
            );
        },
        60 * 1000
    );
}

function download_unavailable() {
    console.log('- download_unavailable()');
    set_ok_modal();
    title = 'No Update Found';
    msg = 'Your Ellipsis Jetpack is up to date.';
    set_modal_content(title, msg);
}

function download_otadm_background() {
    console.log('- download_otadm_background()');
    set_ok_modal();
    title = 'Download Temporarily Unavailable';
    msg = 'Software download is temporarily not available. Please try later.';
    set_modal_content(title, msg);
}

function download_network_error() {
    console.log('- download_network_error()');
    set_ok_modal();
    title = 'Network Unavailable';
    msg = 'Network is not available. Please try later.';
    set_modal_content(title, msg);
}

function download_now() {
    console.log('- download_now()');
    // clear automatic download
    clearTimeout(GLBV.tmr_download);
    // request down now
    var cgi = '/vzw/cgi-bin/settings_software_update.cgi',
        req = { Command : "DownloadNow" };
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function (data) {
            console.log('. download_now() : get_json_by_post - SUCCESS :', data);
            // start checking download progress by request_download_progress()
            data['Response'] === 'Success' ? setTimeout(request_download_progress, GLBV.wait_interval) : download_fail();
        },
        download_fail
    );
    // change modal window
    set_modal_lock();
    title = 'Downloading Update';
    msg = 'A software update from Verizon Wireless is being downloaded to your Jetpack.<br><br>'
      + '<div class="progress active" style="margin-bottom: 0px;">'
      + '  <div class="progress-bar progress-bar-danger" role="progressbar"'
      + '    aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%">'
      + '  </div>'
      + '</div>'
      + '<p id="progress-text" class="pull-right">0%</p><br>'
      + '<p class="pull-left">Please Wait...</p><br>';
    set_modal_content(title, msg);
}

function download_later() {
    console.log('- download_later()');
    // clear automatic download
    clearTimeout(GLBV.tmr_download);
    // actually nothing is done in the device
    var cgi = '/vzw/cgi-bin/settings_software_update.cgi',
        req = { Command : "CancelDownloadUpdate" };
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function (data) {
            console.log('. download_later() : get_json_by_post - SUCCESS :', data);
        }
    );
}

function check_download_progress(data) {
    console.log('. check_download_progress():', data);
    if (data['Status'] === 'In-Progress') {
        if (data['Progress']) {
            set_progress(data['Progress']);
        }
        setTimeout(request_download_progress, GLBV.check_progress_interval);
    } else if (data['Status'] === 'Complete') {
        download_success();
    } else if (data['Status'] === 'Error') {
        download_fail();
    } else {
        console.warn('w check_download_progress() : Not expected status -', data['Status']);
        setTimeout(request_download_progress, GLBV.check_progress_interval);
    }
}

function request_download_progress() {
    console.log('. request_download_progress()');
    var cgi = '/vzw/cgi-bin/settings_software_update.cgi',
        req = { Command: "DownloadProgress" };
    $.ajax({
        type: "POST",
        dataType: "json",
        timeout: 10000,
        url: cgi,
        data: JSON.stringify(req),
        success: check_download_progress,
        error: function (jqxhr, status, err) {
            check_download_progress({ Status: 'Error' });
        }
    });
}

function download_success() {
    console.log('- download_success()');
    set_progress(100); // for animation effect
    $(document).off('modal.answer.ok');
    set_ok_cancel_modal();
    set_modal_button('.btn-ok', 'Yes, Install Now', false);
    set_modal_button('.btn-cancel', 'No, Install Later', true);
    title = 'Download Successful';
    msg = 'New software downloaded successfully. '
        + 'The updated software downloaded successfully. Would you like to install the update now? Your Jetpack will be unusable while the update is installed.<br><br>'
        + '<div class="progress active" style="margin-bottom: 0px;">'
        + '  <div class="progress-bar progress-bar-danger" role="progressbar"'
        + '    aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width: 100%">'
        + '  </div>'
        + '</div>'
        + '<p id="progress-text" class="pull-right">100%</p>';
    set_modal_content(title, msg);

    // set_ok_cancel_modal() calls unbind_answer_handler();
    bind_answer_handler('ok', install_now);
    bind_answer_handler('cancel', install_later);

    // Request InstallLater automatically after 20 sec.
    GLBV.tmr_install = setTimeout(
        function() {
            console.log('. download_success() : 20 sec passed. request InstallLater automatically.');
            hide_modal();
            install_later();
        },
        20 * 1000
    );
}

function download_fail() {
    console.log('- download_fail()');
    set_ok_modal();
    title = 'A New Software Downloading';
    msg = 'There was a problem downloading software.<br>'
        + 'Downloading has been cancelled. Please try later.';
    set_modal_content(title, msg);
}

//----------------------------------------------------------------------

function show_update_available() {
    console.log('- show_update_available()');
    set_ok_cancel_modal();
    set_modal_button('.btn-ok', 'Update Now', false);
    set_modal_button('.btn-cancel', 'Update Later', true);
    title = 'A New Software Avaiable';
    msg = 'New software is downloaded. Would like to update now?';
    show_modal(title, msg);

    // set_ok_cancel_modal() calls unbind_answer_handler();
    bind_answer_handler('answer.ok', install_now);
    bind_answer_handler('answer.cancel', install_later);

    // Request InstallLater automatically after 20 sec.
    GLBV.tmr_install = setTimeout(
        function() {
            console.log('. show_update_available() : 20 sec passed. request InstallLater automatically.');
            hide_modal();
            install_later();
        },
        20 * 1000
    );
}

function install_now() {
    console.log('- install_now()');
    // clear automatic install
    clearTimeout(GLBV.tmr_install);
    // request install now
    var cgi = '/vzw/cgi-bin/settings_software_update.cgi',
        req = { Command : "InstallNow" };
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function (data) {
            console.log('. install_now() : get_json_by_post - SUCCESS :', data);
            // start checking install_progress by request_install_progress()
            data['Response'] === 'Success' ? setTimeout(request_install_progress, GLBV.wait_interval) : install_fail();
        },
        install_fail
    );

    // change modal window
    set_modal_lock();
    title = 'Installing Update';
    msg = 'Please wait while the update is installed.<br><br>'
      + '<div class="progress active" style="margin-bottom: 0px;">'
      + '  <div class="progress-bar progress-bar-danger" role="progressbar"'
      + '    aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%">'
      + '  </div>'
      + '</div>'
      + '<p id="progress-text" class="pull-right">0%</p><br>'
      + '<p id="remaintime-text" class="pull-left">The update will take about 3 minutes.</p><br>';
    set_modal_content(title, msg);
}

function install_later() {
    console.log('- install_later()');
    // clear automatic install
    clearTimeout(GLBV.tmr_install);
    // actually nothing is done in the device
    var cgi = '/vzw/cgi-bin/settings_software_update.cgi',
        req = { Command : "InstallLater" };
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function (data) {
            console.log('. install_later() : get_json_by_post - SUCCESS :', data);
        }
    );
}

//----------------------------------------------------------------------

function check_install_progress(data) {
    console.log('. check_install_progress() :', data);
    if (data['Status'] === 'In-Progress') {
        if (data['Progress']) {
            set_progress(data['Progress']);
        }
        setTimeout(request_install_progress, GLBV.check_progress_interval);
    } else if (data['Status'] === 'Complete') {
        install_success();
    } else if (data['Status'] === 'Error') {
        install_fail(data['ErrMsg']);
    } else {
        console.warn('w check_install_progress() : Not expected status -', data['Status']);
        setTimeout(request_install_progress, GLBV.check_progress_interval);
    }
}

function request_install_progress() {
    console.log('. request_install_progress()');
    var cgi = '/vzw/cgi-bin/settings_software_update.cgi',
        req = { Command: "InstallProgress" };
    $.ajax({
        type: "POST",
        dataType: "json",
        timeout: 5000,
        url: cgi,
        data: JSON.stringify(req),
        success: check_install_progress,
        error: function (jqxhr, status, err) {
            check_install_progress({ Status: 'Complete' }); // No reply from device means that the device is rebooting
        }
    });
}

function install_success() {
    console.log('- install_success()');
    set_progress(100); // for animation effect
    set_modal_lock();
    title = 'Software Update Successful';
    msg = 'The software on your Ellipsis Jetpack has been succefully updated.<br><br>'
      + '<div class="progress active" style="margin-bottom: 0px;">'
      + '  <div class="progress-bar progress-bar-danger" role="progressbar"'
      + '    aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width: 100%">'
      + '  </div>'
      + '</div>'
      + '<p id="progress-text" class="pull-right">100%</p>'
      + '<br>Your Jetpack is restarting.';
    set_modal_content(title, msg);
    request_system_reset();
    setTimeout(function(){hide_modal(); start_wait_reboot_done();}, 5 *1000);
}

function request_system_reset() {
    var cgi = '/vzw/cgi-bin/settings_software_update.cgi',
        req = { Command: 'SystemReset' };
    get_json_by_post(
        cgi,
        JSON.stringify(req),
        function() {
            $('#div_modal').modal('hide');
            start_wait_reboot_done();
        },
        show_reset_error
    );
}

function install_fail(err_msg) {
    console.log('- install_fail()');
    set_ok_modal();
    title = 'Software Update';
    msg = 'There was a problem updating your Jetpack.<br>'
        + 'No changes were made.';
    msg = err_msg ? (msg + '<br>(' + err_msg + ')') : msg;
    set_modal_content(title, msg);
    //setTimeout(request_system_reset, 5 *1000);
}

function show_reset_error() {
    console.log('- show_reset_error()');
    set_modal_lock();
    title = 'Software Update';
    msg = 'Please turn your Jetpack off and on.';
    set_modal_content(title, msg);
}

//----------------------------------------------------------------------

function set_progress(progress) {
    progress = getParseInt(progress);
    $('.progress-bar').css('width', progress + '%');
    $('#progress-text').html(progress + '%');
}
